# Cooperative MARL

Create a new conda environment:
```
conda create --name marl
```
Install pip and python in the new environment:
```
conda install pip
conda install python=3.10
```
Install torch depending on your CUDA version:
```
conda install pytorch torchvision torchaudio pytorch-cuda=12.1 -c pytorch -c nvidia
```
Install recent tensordict:
```
pip install git+https://github.com/pytorch-labs/tensordict
```
Build torchrl dependencies:
```
python setup.py develop
```
Get dependencies:
```
pip install -r requirements.txt
```
Run training:
```
python3 run.py configs/halluc_ddpg.yaml --gpu-device 0
```